SparseObjectMatrix3D (Colt 1.2.0 - API Specification)
Keywords: cern.colt.matrix.impl.SparseObjectMatrix3D class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Colt 1.2.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## cern.colt.matrix.impl
Class SparseObjectMatrix3D

    java.lang.Object
      cern.colt.PersistentObject
          cern.colt.matrix.impl.AbstractMatrix
              cern.colt.matrix.impl.AbstractMatrix3D
                  cern.colt.matrix.ObjectMatrix3D
                      cern.colt.matrix.impl.SparseObjectMatrix3D

All Implemented Interfaces:
  Cloneable, Serializable

public class SparseObjectMatrix3D
extends ObjectMatrix3D

Sparse hashed 3-d matrix holding `Object` elements. First see the package summary and javadoc tree view to get the broad picture.

Implementation:

Note that this implementation is not synchronized. Uses a `OpenIntObjectHashMap`, which is a compact and performant hashing technique.

Memory requirements:

Cells that

- are never set to non-zero values do not use any memory.
- switch from zero to non-zero state do use memory.
- switch back from non-zero to zero state also do use memory. However, their memory is automatically reclaimed from time to time. It can also manually be reclaimed by calling `trimToSize()`.

worst case: `memory [bytes] = (1/minLoadFactor) * nonZeros * 13`.
best case: `memory [bytes] = (1/maxLoadFactor) * nonZeros * 13`.
Where `nonZeros = cardinality()` is the number of non-zero cells. Thus, a 100 x 100 x 100 matrix with minLoadFactor=0.25 and maxLoadFactor=0.5 and 1000000 non-zero cells consumes between 25 MB and 50 MB. The same 100 x 100 x 100 matrix with 1000 non-zero cells consumes between 25 and 50 KB.

Time complexity:

This class offers expected time complexity `O(1)` (i.e. constant time) for the basic operations `get`, `getQuick`, `set`, `setQuick` and `size` assuming the hash function disperses the elements properly among the buckets. Otherwise, pathological cases, although highly improbable, can occur, degrading performance to `O(N)` in the worst case. As such this sparse class is expected to have no worse time complexity than its dense counterpart `DenseObjectMatrix2D`. However, constant factors are considerably larger.

Cells are internally addressed in (in decreasing order of significance): slice major, row major, column major. Applications demanding utmost speed can exploit this fact. Setting/getting values in a loop slice-by-slice, row-by-row, column-by-column is quicker than, for example, column-by-column, row-by-row, slice-by-slice. Thus

       for (int slice=0; slice < slices; slice++) {
              for (int row=0; row < rows; row++) {
                 for (int column=0; column < columns; column++) {
                            matrix.setQuick(slice,row,column,someValue);
                     }
              }
       }

is quicker than

       for (int column=0; column < columns; column++) {
              for (int row=0; row < rows; row++) {
                 for (int slice=0; slice < slices; slice++) {
                            matrix.setQuick(slice,row,column,someValue);
                     }
              }
       }

Version:
  1.0, 09/24/99
See Also:
  `cern.colt.map`, `OpenIntObjectHashMap`, Serialized Form

Field Summary

Fields inherited from class cern.colt.PersistentObject
`serialVersionUID`

Constructor Summary
`SparseObjectMatrix3D(int slices, int rows, int columns)` Constructs a matrix with a given number of slices, rows and columns and default memory usage.
`SparseObjectMatrix3D(int slices, int rows, int columns, int initialCapacity, double minLoadFactor, double maxLoadFactor)` Constructs a matrix with a given number of slices, rows and columns using memory as specified.
`SparseObjectMatrix3D(Object[][][] values)` Constructs a matrix with a copy of the given values.

Method Summary
`int` | `cardinality()` Returns the number of cells having non-zero values.
`void` | `ensureCapacity(int minCapacity)` Ensures that the receiver can hold at least the specified number of non-zero cells without needing to allocate new internal memory.
`Object` | `getQuick(int slice, int row, int column)` Returns the matrix cell value at coordinate `[slice,row,column]`.
`ObjectMatrix3D` | `like(int slices, int rows, int columns)` Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of slices, rows and columns.
`void` | `setQuick(int slice, int row, int column, Object value)` Sets the matrix cell at coordinate `[slice,row,column]` to the specified value.
`void` | `trimToSize()` Releases any superfluous memory created by explicitly putting zero values into cells formerly having non-zero values; An application can use this operation to minimize the storage of the receiver.

Methods inherited from class cern.colt.matrix.ObjectMatrix3D
`aggregate, aggregate, assign, assign, assign, assign, assign, copy, equals, equals, get, getNonZeros, like, set, toArray, toString, viewColumn, viewColumnFlip, viewDice, viewPart, viewRow, viewRowFlip, viewSelection, viewSelection, viewSlice, viewSliceFlip, viewSorted, viewStrides`

Methods inherited from class cern.colt.matrix.impl.AbstractMatrix3D
`checkShape, checkShape, columns, rows, size, slices, toStringShort`

Methods inherited from class cern.colt.PersistentObject
`clone`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SparseObjectMatrix3D

    public SparseObjectMatrix3D(Object[][][] values)

  Constructs a matrix with a copy of the given values. `values` is required to have the form `values[slice][row][column]` and have exactly the same number of rows in in every slice and exactly the same number of columns in in every row.

  The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

Parameters:
  `values` - The values to be filled into the new matrix.
Throws:
  `IllegalArgumentException` - if `for any 1 <= slice < values.length: values[slice].length != values[slice-1].length`.
  `IllegalArgumentException` - if `for any 1 <= row < values[0].length: values[slice][row].length != values[slice][row-1].length`.

### SparseObjectMatrix3D

    public SparseObjectMatrix3D(int slices,
                                int rows,
                                int columns)

  Constructs a matrix with a given number of slices, rows and columns and default memory usage. All entries are initially `null`.

Parameters:
  `slices` - the number of slices the matrix shall have.
  `rows` - the number of rows the matrix shall have.
  `columns` - the number of columns the matrix shall have.
Throws:
  `IllegalArgumentException` - if `(double)slices*columns*rows > Integer.MAX_VALUE`.
  `IllegalArgumentException` - if `slices<0 || rows<0 || columns<0`.

### SparseObjectMatrix3D

    public SparseObjectMatrix3D(int slices,
                                int rows,
                                int columns,
                                int initialCapacity,
                                double minLoadFactor,
                                double maxLoadFactor)

  Constructs a matrix with a given number of slices, rows and columns using memory as specified. All entries are initially `null`. For details related to memory usage see `OpenIntObjectHashMap`.

Parameters:
  `slices` - the number of slices the matrix shall have.
  `rows` - the number of rows the matrix shall have.
  `columns` - the number of columns the matrix shall have.
  `initialCapacity` - the initial capacity of the hash map. If not known, set `initialCapacity=0` or small.
  `minLoadFactor` - the minimum load factor of the hash map.
  `maxLoadFactor` - the maximum load factor of the hash map.
Throws:
  `IllegalArgumentException` - if `initialCapacity < 0 || (minLoadFactor < 0.0 || minLoadFactor >= 1.0) || (maxLoadFactor <= 0.0 || maxLoadFactor >= 1.0) || (minLoadFactor >= maxLoadFactor)`.
  `IllegalArgumentException` - if `(double)slices*columns*rows > Integer.MAX_VALUE`.
  `IllegalArgumentException` - if `slices<0 || rows<0 || columns<0`.

Method Detail

### cardinality

    public int cardinality()

  Returns the number of cells having non-zero values.

  Overrides:
    `cardinality` in class `ObjectMatrix3D`

### ensureCapacity

    public void ensureCapacity(int minCapacity)

  Ensures that the receiver can hold at least the specified number of non-zero cells without needing to allocate new internal memory. If necessary, allocates new internal memory and increases the capacity of the receiver.

  This method never need be called; it is for performance tuning only. Calling this method before tt>set()ing a large number of non-zero values boosts performance, because the receiver will grow only once instead of potentially many times and hash collisions get less probable.

  Overrides:
    `ensureCapacity` in class `AbstractMatrix`
  Parameters:
    `minCapacity` - the desired minimum number of non-zero (non-null) cells.

### getQuick

    public Object getQuick(int slice,
                           int row,
                           int column)

  Returns the matrix cell value at coordinate `[slice,row,column]`.

  Provided with invalid parameters this method may return invalid objects without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `slice<0 || slice>=slices() || row<0 || row>=rows() || column<0 || column>=column()`.

  Specified by:
    `getQuick` in class `ObjectMatrix3D`
  Parameters:
    `slice` - the index of the slice-coordinate.
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
  Returns:
    the value at the specified coordinate.

### like

    public ObjectMatrix3D like(int slices,
                               int rows,
                               int columns)

  Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of slices, rows and columns. For example, if the receiver is an instance of type `DenseObjectMatrix3D` the new matrix must also be of type `DenseObjectMatrix3D`, if the receiver is an instance of type `SparseObjectMatrix3D` the new matrix must also be of type `SparseObjectMatrix3D`, etc. In general, the new matrix should have internal parametrization as similar as possible.

  Specified by:
    `like` in class `ObjectMatrix3D`
  Parameters:
    `slices` - the number of slices the matrix shall have.
    `rows` - the number of rows the matrix shall have.
    `columns` - the number of columns the matrix shall have.
  Returns:
    a new empty matrix of the same dynamic type.

### setQuick

    public void setQuick(int slice,
                         int row,
                         int column,
                         Object value)

  Sets the matrix cell at coordinate `[slice,row,column]` to the specified value.

  Provided with invalid parameters this method may access illegal indexes without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `slice<0 || slice>=slices() || row<0 || row>=rows() || column<0 || column>=column()`.

  Specified by:
    `setQuick` in class `ObjectMatrix3D`
  Parameters:
    `slice` - the index of the slice-coordinate.
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
    `value` - the value to be filled into the specified cell.

### trimToSize

    public void trimToSize()

  Releases any superfluous memory created by explicitly putting zero values into cells formerly having non-zero values; An application can use this operation to minimize the storage of the receiver.

  Background:

  Cells that

  - are never set to non-zero values do not use any memory.
  - switch from zero to non-zero state do use memory.
  - switch back from non-zero to zero state also do use memory. However, their memory can be reclaimed by calling `trimToSize()`.
  A sequence like `set(s,r,c,5); set(s,r,c,0);` sets a cell to non-zero state and later back to zero state. Such as sequence generates obsolete memory that is automatically reclaimed from time to time or can manually be reclaimed by calling `trimToSize()`. Putting zeros into cells already containing zeros does not generate obsolete memory since no memory was allocated to them in the first place.

  Overrides:
    `trimToSize` in class `AbstractMatrix`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Colt 1.2.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Jump to the Colt Homepage